 
import cats.*;
import java.sql.*;
import java.util.*;
import org.omg.CORBA.*;


class CatAccessServant extends _CatAccessImplBase {

    Connection con;

    CatAccessServant() {
    }
	
    private void connectToSql() throws Exception {
	String url = "jdbc:msql://localhost:1114/DBTest";
	Properties p = new Properties();
  
	p.put("user", "balazs");
       	Class.forName("com.imaginary.sql.msql.MsqlDriver");
   	con = DriverManager.getConnection(url, "balazs", "");
		
    }

    public cats.Person[] getPersons()
      {
	Vector vector = new Vector();
	try
	  {
  	    connectToSql();
	    
	    Statement stmt;
	    ResultSet rs;
	    stmt = con.createStatement();
	    rs = stmt.executeQuery("select * from Person");

	    while( rs.next() ) 
	      {
		Person rec = new Person();

		rec.name = rs.getString("name");
		rec.department = rs.getString("department");

		vector.add(rec);
	      }
	    
	    con.close();
	  }
	catch (Exception e)
	  {
	    debug("getPersons() "+e);
	  }
	
	Person[] ret = new Person[vector.size()];
	ret = (Person[])vector.toArray(ret);

	return ret;
	
      }

    public cats.Cat[] getCats(String owner)
      {
	Vector vector = new Vector();
	try
	  {
	    connectToSql();
	    
	    Statement stmt;
	    ResultSet rs;
	    stmt = con.createStatement();
	    String query ="select name, owner from Cat where owner = '"
				   + owner + "'";
	    debug(query);
	    rs = stmt.executeQuery(query);
	    debug("Owner:."+owner+"...");
	   

	    while( rs.next() ) 
	      {
		Cat rec = new Cat();
		rec.name = rs.getString("name");
		rec.owner = rs.getString("owner");
		
		vector.add(rec);
	      }
	    
	    
	    con.close();
	  }
	catch (Exception e)
	  {
	    debug("getCats() "+e);
	  }
	
	Cat[] ret = new Cat[vector.size()];
	ret = (Cat[])vector.toArray(ret);

	return ret;
	
      }

    public byte[] getPicture(String cat)
      {
	byte[] ret = null;
	try
	  {
	    connectToSql();
	    
	    Statement stmt;
	    ResultSet rs;
	    stmt = con.createStatement();
	    rs = stmt.executeQuery("select icon from Cat where name = '"
				   + cat +"'");
	   
	    java.lang.Object o = null;
	    if (rs.next())
	      o = rs.getObject("icon");
	    if (o != null)
	      ret = ((String)o).getBytes();
	    else
	      ret = new byte[0];

	    con.close();
	  }
	catch (Exception e)
	  {
	    debug("getPicture "+e);
	  }
	return ret;
      }
	    

    void debug(String s)
      {
	System.err.println("QueryServant: "+s);
      }


}


